package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.PingChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link PingChecker}の設定を行うパネルです。
*/
public class PingPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_ADDR = new ValuePanel( ValuePanel.ReturnType.STRING, "Address:" );
	ValuePanel	VAL_RETRY = new ValuePanel( ValuePanel.ReturnType.INT, "Retry:" );

	public PingPanel() {
		testChecker = new PingChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_ADDR );
		pnl.add( VAL_RETRY );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		PingChecker mon = (PingChecker )var;
		VAL_ADDR.setValue( mon.getAddress() );
		VAL_RETRY.setValue( String.valueOf( mon.getRetry() ));
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		String var;
		var = (String )VAL_ADDR.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "checker.ping.err1.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		PingChecker mon = (PingChecker )chk;
		mon.setAddress( (String )VAL_ADDR.getValue() );
		Integer var = (Integer )VAL_RETRY.getValue();
		if ( var != null ) {
			mon.setRetry( var.intValue() );
		}
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_ADDR.setEnabled( bEn );
		VAL_RETRY.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return PingChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Address" ), new Column( "Retry" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

